package com.atguigu.user.service.impl;

import com.atguigu.constant.MessageConstant;
import com.atguigu.exception.BunnyException;
import com.atguigu.user.service.SmsService;
import com.atguigu.user.service.module.SmsServiceModule;
import org.apache.commons.lang3.RandomStringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.concurrent.TimeUnit;

@Service
public class SmsServiceImpl implements SmsService {
    @Autowired
    private RedisTemplate<String, Object> redisTemplate;

    /**
     * 发送短信
     *
     * @param phone 手机号
     */
    @Override
    public void sendValidateCode(String phone) throws Exception {
        Object isExist = redisTemplate.opsForValue().get(phone);
        if (isExist != null) {
            throw new BunnyException(MessageConstant.MESSAGE_CODE_NOT_PASS);
        }
        // 1. 生成验证码
        String code = RandomStringUtils.randomNumeric(4);
        // 2. 生成的验证码放到Redis中，设置过期时间
        redisTemplate.opsForValue().set(phone, code, 10, TimeUnit.MINUTES);
        // 3. 向手机发送短信
        SmsServiceModule.sendMessage(phone, code);
    }
}
